/*A module for tracking the angular distribution of particels on the torus.
 prefix is ANG_*/

/*function-get the absultute angle of each particle return an array
 * angle measured from furthest outside point of donut and is the same for +ive and -ive z*/

#include"mc_math_h.h"
#include"std_h.h"
#include"mc_state_h.h"
#include"angular_distribution_h.h"

double * ANG_get_angles(Mc_state *state, double *params) {

	double *angle_list = malloc(sizeof(double)*state->n_particles);
	double v_temp;
	int i;
	for (i = 0; i< state->n_particles;i++) {
		v_temp = asin((fabs(state->z[i]))/params[0]);
		if (state->x[i]*state->x[i] + state->y[i]*state->y[i] < params[1]*params[1]) {
			v_temp = M_PI - v_temp;
		}
		angle_list[i] = v_temp;
	}
	return angle_list;
}
