/*a structure that contains the state of the system for basic mc simulations
 *
 *u: a pointer to an array containing the u coordintate of each particle
 *v: a pointer to an array containing the v coordinate of each particle
 *n_particles: the number of particles in the system
 */

#include"std_h.h"
#include"mc_state_h.h"

/*perform a deep copy of stateI into stateT, destroying the current content of stateT
 *
 * param StateT: the targhet state to be copies to
 * input stateI the copyee. Will not be edited
 **/

void MCS_state_deepCopy(Mc_state *stateT, Mc_state *stateI) {

	int i;
	double *temptr;
	if (stateT->n_particles == stateI->n_particles) {
		for (i = 0; i < stateT->n_particles; i++) {
			stateT->x[i] = stateI->x[i];
			stateT->y[i] = stateI->y[i];
			stateT->z[i] = stateI->z[i];
		}
		return ;
	} else {
		temptr = realloc(stateT->x, sizeof(double)*stateI->n_particles);
		if (temptr != NULL || stateI->n_particles == 0) {
			stateT->x = temptr;
		} else {
			die ("realloc failed in state_deppCopy");
		}		
		
		temptr = realloc(stateT->y,sizeof(double)*stateI->n_particles);
		if (temptr != NULL || stateI->n_particles == 0) {
			stateT->y = temptr;
		} else {
			die ("realloc failed in state_deppCopy");
		}

		temptr = realloc(stateT->z,sizeof(double)*stateI->n_particles);
		if (temptr != NULL || stateI->n_particles == 0) {
			stateT->z = temptr;
		} else {
			die ("realloc failed in state_deppCopy");
		}
		
		stateT->n_particles = stateI->n_particles;

		for (i = 0; i < stateT->n_particles; i++) {
			stateT->x[i] = stateI->x[i];
			stateT->y[i] = stateI->y[i];
			stateT->z[i] = stateI->z[i];
		}
	
	}

}

/*perform a clone of stateI into the (uninitialised struct) stateT
 *
 * param StateT: the targhet state to be copies to
 * input stateI the copyee. Will not be edited
 **/

void MCS_state_clone (Mc_state *stateT, Mc_state *stateI) {

	stateT->n_particles = stateI->n_particles;

	stateT->x = malloc(sizeof(double)*stateT->n_particles);
	stateT->y = malloc(sizeof(double)*stateT->n_particles);
	stateT->z = malloc(sizeof(double)*stateT->n_particles);

	int i;
	for (i=0; i < stateT->n_particles; i++) {
		stateT->x[i] = stateI->x[i];
		stateT->y[i] = stateI->y[i];
		stateT->z[i] = stateI->z[i];
	}

}

/*free an MC struct*/
void MCS_end (Mc_state *state) {
	free(state->x);
	free(state->y);
	free(state->z);
}


