#ifndef REPLICA_EXCHANGE
#define REPLIC_EXCHANGE
#include"mc_state_h.h"
/*A module to handle replica exchange parellel tempering, initially, ony "1D" replica
 exchanges are inplemented. the prefix is RE_*/

/*initialises the mpi library, and gets the rank and soze variables*/
void RE_initialise (int *rank, int *size);

/*ends the parellelisation*/
void RE_end (void);

/*save state in correct place*/
void RE_mc_save(Mc_state *state, char run_id[], double delta_r, double deltaC, double deltaS);

/*a function for attempting a replica exchange wit ha process further down the list of replicas
 * this function does not handle accept/reject, which is delt with by the exchange_up function
 *
 * Output: 1 if success else 0
 * Input: var: the system variable need ed for the acceptance check. eg the total energy or
		the particle number etc.
 *param: param: the parameter to be exchangeg eg. temperature
 *param delta[]: move distances to be transfered
 *input: n_delta: number of move distances
 *input rank, current mpi rank
 *iparam i_sim, the index of this simulation 
 */

int RE_exchange_down(double var, double *param, double *delta, int n_delta, int rank, int *i_sim);

/*a function for attempting a replica exchange wit ha process further up the list of replicas
 * this function does handle accept/reject.
 * Output: 1 if success else 0
 * Input: var: the system variable need ed for the acceptance check. eg the total energy or
		the particle number etc.
 *param: param: the parameter to be exchangeg eg. temperature
 *param delta[]: move distances to be transfered
 *input: n_delta: number of move distances
 *function RE_accept:
 */

int RE_exchange_up(double var, double *param, double *delta, int n_delta, int rank, int *i_sim,
			int(*RE_accept)(double var1, double var2, double param1, double param2));


/*The acceptence rule for temperature exchanges
 *
 * output 1: accept 0:reject
 * input en1, en2: the energies of the exchanging systems
 * input eps1, eps2: the inverse temperatures of the exchanging systems
 */
int RE_accept_temperature (double en1,double en2,double eps1,double eps2); 

/*The acceptence rule for temperature exchanges
 *
 * output 1: accept 0:reject
 * input num1, num2: the number of particles is sytem one and two
 * input act1 act2: the activities in systems 1 and 2
 */

int RE_accept_activity (double num1, double num2, double act1, double act2);

/*
 *The acceptence rule for n_target exchanges
 *
 * output 1: accept 0:reject
 * input n_lambda1, n_lambda2: the size of the largest cluster times lambda
 * input n_t1, n_t2; the size of the target cluster
 */

int RE_accept_n_target (double n_lambda1, double n_lambda2, double n_t1, double n_t2);

#endif
