/*a module for calculating the weighted average angle of a cluster on a torus
 * module prefix is TAK_
 */


#include"mc_math_h.h"
#include"std_h.h"
#include"mc_state_h.h"
#include"torus_cluster_angle_h.h"

double TAK_get_angle(Mc_state *state, double *params) {
	int i;
	double angle,metric,x,y;
	double sum_x = 0.0;
	double sum_y = 0.0;
	
	/*for each particle*/
	for(i = 0; i < state->n_particles;i++) {
		/*get angle*/
		angle = asin((fabs(state->z[i]))/params[0]);
		if (state->x[i]*state->x[i] + state->y[i]*state->y[i] < params[1]*params[1]) {
			if (state->z[i] > 0) {
				angle = M_PI - angle;
			} else {
				angle = M_PI + angle;
			}
		} else if (state->z[i] < 0) {
			angle = 2*M_PI - angle;
		}

		/*get metric*/
		metric = params[1] + params[0]*cos(angle);
		/*add to totals*/
		x =   params[0]*cos(angle);
		y =   params[0]*sin(angle);

		
		sum_x += x/(metric);
		sum_y += y/(metric);
		
		/*
		sum_x += x;
		sum_y += y;
		sum_m += 1.0;
		*/
		
		
		
	}

	/*calculate "COM"*/

	double cox = sum_x;
	double coy = sum_y;
	angle = asin(   fabs(coy) / sqrt(cox*cox+coy*coy));
	if (cox < 0) {
		if (coy > 0) {
			angle = M_PI - angle;
		} else {
			angle = M_PI + angle;
		}
	} else if (coy < 0) {
		angle = 2*M_PI - angle;
	}
	return angle;
}
